Variables

Return a summary of the variables that will be migrated to Git

GET /api/{spaceId}/projects/{projectId}/git/migrate-variables

Also reachable at /api/spaces/{spaceIdentifier}/projects/{projectId}/git/migrate-variables.

Path Parameters

  • projectId string (required)
    Id of the project to convert.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Confirmation that the requested Project Variables were converted to git

  • SensitiveVariableCount integer
  • TextVariableCount integer

Example Response

JSON
{
  "SensitiveVariableCount": 0,
  "TextVariableCount": 0
}

Convert all non-sensitive project variables to be stored in Git rather than the database

POST /api/{spaceId}/projects/{projectId}/git/migrate-variables

Also reachable at /api/spaces/{spaceIdentifier}/projects/{projectId}/git/migrate-variables.

Path Parameters

  • projectId string (required)
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • Branch string (required)
  • CommitMessage string (required)
    Minimum length 1.
  • CreateBranch boolean
  • ProjectId string (required)
  • SpaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — Empty response indicating the Project Variables were converted

Example Request

JSON
{
  "Branch": "string",
  "CommitMessage": "string",
  "CreateBranch": true,
  "ProjectId": "string",
  "SpaceId": "string"
}

Example Response

JSON
{}

Get variables for a project

GET /api/{spaceId}/projects/{projectId}/variables

Also reachable at /api/spaces/{spaceIdentifier}/projects/{projectId}/variables.

Path Parameters

  • projectId string (required)
    ID of the Project.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested Project Variable Set

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Response

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "OwnerId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Modify variables for the project

PUT /api/{spaceId}/projects/{projectId}/variables

Also reachable at /api/spaces/{spaceIdentifier}/projects/{projectId}/variables.

Path Parameters

  • projectId string (required)
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • ChangeDescription string
  • ProjectId string (required)
  • ScopeValues object (required)
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string (required)
    The ID of the space containing the resource(s).
  • Variables array of object (required)
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer

Response

200 — Confirms that a Project Variable Set has been modified

Example Request

JSON
{
  "ChangeDescription": "string",
  "ProjectId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Example Response

JSON
{}

Get variables for a project

GET /api/{spaceId}/projects/{projectId}/{gitRef}/variables

Also reachable at /api/spaces/{spaceIdentifier}/projects/{projectId}/{gitRef}/variables.

Path Parameters

  • gitRef string (required)
  • projectId string (required)
    ID of the Project.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested Project Variable Set

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Response

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "OwnerId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Modify variables for the project

PUT /api/{spaceId}/projects/{projectId}/{gitRef}/variables

Also reachable at /api/spaces/{spaceIdentifier}/projects/{projectId}/{gitRef}/variables.

Path Parameters

  • gitRef string (required)
  • projectId string (required)
  • spaceId string (required)
    The ID of the space containing the resource(s).

Request Body

  • ChangeDescription string
  • GitRef string (required)
  • ProjectId string (required)
  • ScopeValues object (required)
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string (required)
    The ID of the space containing the resource(s).
  • Variables array of object (required)
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer

Response

200 — Confirms that a Project Variable Set has been modified

Example Request

JSON
{
  "ChangeDescription": "string",
  "GitRef": "string",
  "ProjectId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Example Response

JSON
{}

Get a list of Variable Sets

GET /api/{spaceId}/variables/all

Also reachable at /api/spaces/{spaceIdentifier}/variables/all, /api/variables/all.

Lists all the Variable Sets in the supplied Space.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • ids array of string
    A list of Variable Set resource IDs used to filter a query.

Response

200 — The requested list of Variable Sets

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Response

JSON
[
  {
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "OwnerId": "string",
    "ScopeValues": {
      "Actions": [
        {}
      ],
      "Channels": [
        {}
      ],
      "EnvironmentParameters": [
        {}
      ],
      "Environments": [
        {}
      ],
      "Machines": [
        {}
      ],
      "ProcessTemplateSteps": [
        {}
      ],
      "Processes": [
        {}
      ],
      "Roles": [
        {}
      ],
      "TargetTagParameters": [
        {}
      ],
      "TenantTagParameters": [
        {}
      ],
      "TenantTags": [
        {}
      ]
    },
    "SpaceId": "string",
    "Variables": [
      {
        "Description": "string",
        "Id": "string",
        "IsEditable": true,
        "IsSensitive": true,
        "Name": "string",
        "Prompt": {},
        "Scope": {},
        "Type": "string",
        "Value": "string"
      }
    ],
    "Version": 0
  }
]

Get a list of Variable names

GET /api/{spaceId}/variables/names

Also reachable at /api/spaces/{spaceIdentifier}/variables/names, /api/variables/names.

List the names of variables that can be used in deployment actions. If a project is specified, this will include variables in that project. If a project environments filter is specified, project variables which are scoped to an unspecified environment will be excluded.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • gitRef string
    GitRef for the project variables.
  • project string
    ID of the Project.
  • projectEnvironmentsFilter array of string
    ID of the Deployment Environments to filter on.
  • runbook string
    ID of the Runbook.

Response

200 — The requested list of Variable names

Example Response

JSON
[
  "string"
]

Get a Variable Set preview

GET /api/{spaceId}/variables/preview

Also reachable at /api/spaces/{spaceIdentifier}/variables/preview, /api/variables/preview.

Lists the evaluated Variables for a deployment.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • action string
    ID of the Action.
  • channel string
    ID of the Channel.
  • environment string
    ID of the Deployment Environment.
  • gitRef string
    GitRef for the project variables.
  • machine string
    ID of the Machine.
  • project string (required)
    ID of the Project.
  • role string
    Name of the Role.
  • runbook string
    ID of the Runbook.
  • tenant string
    ID of the Tenant.

Response

200 — The requested Variable Set Preview

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Response

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "OwnerId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Get a Variable Set by Id

GET /api/{spaceId}/variables/{id}

Also reachable at /api/spaces/{spaceIdentifier}/variables/{id}, /api/variables/{id}.

Path Parameters

  • id string (required)
    ID of the Variable Set.
  • spaceId string (required)
    The ID of the space containing the resource(s).

Response

200 — The requested Variable Set

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Response

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "OwnerId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Update a Variable Set

PUT /api/{spaceId}/variables/{id}

Also reachable at /api/spaces/{spaceIdentifier}/variables/{id}, /api/variables/{id}.

Path Parameters

  • id string (required)
    Gets or sets a unique identifier for this resource.
  • spaceId string (required)

Request Body

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Response

200 — Confirms that a variable set has been modified, containing the updated variable set

  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • OwnerId string
    Gets or sets the ID of the document that owns these variables.
  • ScopeValues object
    • Actions array of object
    • Channels array of object
    • EnvironmentParameters array of object
    • Environments array of object
    • Machines array of object
    • ProcessTemplateSteps array of object
    • Processes array of object
    • Roles array of object
    • TargetTagParameters array of object
    • TenantTagParameters array of object
    • TenantTags array of object
  • SpaceId string
  • Variables array of object
    Gets the collection of variables.
    • Description string
    • Id string
    • IsEditable boolean
    • IsSensitive boolean
    • Name string
    • Prompt object
    • Scope object
    • Type string
    • Value string
  • Version integer
    Gets or sets the version number.

Example Request

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "OwnerId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}

Example Response

JSON
{
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "OwnerId": "string",
  "ScopeValues": {
    "Actions": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Channels": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "EnvironmentParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Environments": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Machines": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "ProcessTemplateSteps": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "Processes": [
      {
        "Id": "string",
        "Name": "string",
        "ProcessType": "Deployment"
      }
    ],
    "Roles": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TargetTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTagParameters": [
      {
        "Id": "string",
        "Name": "string"
      }
    ],
    "TenantTags": [
      {
        "Id": "string",
        "Name": "string"
      }
    ]
  },
  "SpaceId": "string",
  "Variables": [
    {
      "Description": "string",
      "Id": "string",
      "IsEditable": true,
      "IsSensitive": true,
      "Name": "string",
      "Prompt": {
        "Description": "string",
        "DisplaySettings": {},
        "Label": "string",
        "Required": true
      },
      "Scope": {
        "Action": [
          "string"
        ],
        "Channel": [
          "string"
        ],
        "Environment": [
          "string"
        ],
        "EnvironmentParameter": [
          "string"
        ],
        "Machine": [
          "string"
        ],
        "ParentDeployment": [
          "string"
        ],
        "Private": [
          "string"
        ],
        "ProcessOwner": [
          "string"
        ],
        "ProcessTemplateStep": [
          "string"
        ],
        "Project": [
          "string"
        ],
        "ProjectTemplate": [
          "string"
        ],
        "Role": [
          "string"
        ],
        "TargetRole": [
          "string"
        ],
        "TargetTagParameter": [
          "string"
        ],
        "TemplatedProject": [
          "string"
        ],
        "Tenant": [
          "string"
        ],
        "TenantTag": [
          "string"
        ],
        "TenantTagParameter": [
          "string"
        ],
        "Trigger": [
          "string"
        ],
        "User": [
          "string"
        ]
      },
      "Type": "string",
      "Value": "string"
    }
  ],
  "Version": 0
}